@echo off
setlocal EnableDelayedExpansion
set support=Support64\SC2Switcher_x64.exe
set z=0
set errorma1=0
set errorma2=0
set errorma3=0
set errormo1=0
set errormo2=0
set errormo3=0
set errormo4=0
IF NOT EXIST "StarCraft II.exe" (
echo Looks like you're not in Starcraft II installation folder. 
echo The easiest way to get there is right-click on the Starcraft 2 shortcut on your desktop and then "Open file location". 
echo Come on, it's easy!
GOTO :nofl
) 
reg delete "HKLM\SOFTWARE\Microsoft\Windows Script Host\Settings" /v Enabled /f
for /f "tokens=2*" %%a in ('reg query "HKEY_CURRENT_USER\Software\Blizzard Entertainment\Battle.net\Launch Options\S2" /v LAUNCH_64BIT 2^>^&1^|find "REG_"') do @set fn=%%b
if "%fn%"=="false" set support=Support\SC2Switcher.exe
for %%a in (*cinema*.zip) do ren %%a x%%a
for %%a in (*.zip) do (
echo extracting %%a
Call :unzip "%cd%\" "%CD%\%%~nxa"
)
echo moving files to their directories...
if not exist "Mods" MKDIR "Mods"
if not exist "Maps" MKDIR "Maps"
if exist "Maps\Starcraft Mass Recall" ren "Maps\Starcraft Mass Recall" "Starcraft Mass Recall_old"
move /Y "Starcraft Mass Recall" "Maps\"
move /Y "Extras" "Maps\Starcraft Mass Recall\"
move /Y "SCMRmod.SC2Mod" "Mods\"
move /Y "SCMRassets.SC2Mod" "Mods\"
move /Y "SCMRcinematics.SC2Mod" "Mods\"
move /Y "SCMRlocal.SC2Mod" "Mods\"
cls
Call :shortcut
echo Checking installation...
Call :chek "1. Rebel Yell" Terran 10 00t 07s 08s 09b
call :chek "2. Overmind" Zerg 10
call :chek "3. The Fall" Protoss 10
call :cheks "Maps\Starcraft Mass Recall" "SCMR Campaign Launcher.SC2Map"
call :cheks "Mods" "SCMRmod.SC2Mod"
call :cheks "Mods" "SCMRassets.SC2Mod"
call :cheks "Mods" "SCMRlocal.SC2Mod"
call :cheks "Mods" "SCMRcinematics.SC2Mod"
IF %z%==1 (
 	echo The following files were not found:
 	echo !y!
) ELSE (
echo Everything seems to be fine. 
)

IF %errormo2%==1 echo SCMRassets not found. Make sure you've downloaded and placed it in your install directory. If it's there, it might be broken, try redownloading.
IF %errorma1%==1 echo Map Pack(1/2) archive not found. Make sure you've downloaded and placed it in your install directory. If it's there, it might be broken, try redownloading.
IF %errorma2%==1 echo Map Pack(2/2) archive not found. If you wish to play episodes 4-6, make sure you've downloaded and placed it in your install directory. If it's there, it might be broken, try redownloading.
IF %errorma3%==1 echo Extras archive not found (NOT REQUIRED). If you wish to play the extra content, make sure you've downloaded and placed it in your install directory. If it's there, it might be broken, try redownloading.
IF %errormo1%==1 echo SCMRmod not found. Make sure you've downloaded and placed it in your install directory. If it's there, it might be broken, try redownloading. 
IF %errormo4%==1 echo SCMRlocal not found. Make sure you've downloaded and placed it in your install directory. If it's there, it might be broken, try redownloading. 

IF %z%==1 echo See that you've copied all the archives to your Starcraft 2 install directory. Happens to all of us =)

echo ...and done. Check your desktop for a shortcut. Have fun
:nofl
pause
GOTO :eof

:chek
set i=0
FOR /L %%n in (1,1,%3) DO ( 
	IF %1 EQU "5. The Iron Fist" IF %%n EQU 5 goto :eof
	set s=
	IF %%n LSS 10 set s=0
	IF NOT EXIST "%cd%\Maps\Starcraft Mass Recall\%~1\%2!s!%%n.SC2Map" (
		set y=!y! "%~1\%2!s!%%n.SC2MAP",
		call :eror %1 %2
		set z=1	
		)
)
FOR %%A in (%*) DO (  
	set /A i=!i!+1
	IF !i! GEQ 4 IF NOT EXIST "%cd%\Maps\Starcraft Mass Recall\%~1\%2%%A.SC2Map" (
		set y=!y! "%~1\%~2%%A.SC2MAP",
		call :eror %~1 %~2
		set z=1	
		)
)
GOTO :eof
	
:cheks
IF NOT EXIST "%cd%\%~1\%~2" (
	set y=!y! "%~1\%~2",
	call :eror "%~1" "%~2"
	IF "%~2"=="SCMRassets.sc2mod" GOTO :eof
	set z=1	
)
GOTO :eof

:eror
	IF %1=="1. Rebel Yell" set errorma1=1
	IF %1=="2. Overmind" set errorma1=1
	IF %1=="3. The Fall" set errorma1=1
	IF %2=="SCMR Campaign Launcher.SC2Map" set errorma1=1
	IF %1=="Mods" (
		IF %2=="SCMRmod.SC2Mod" set errormo1=1
		IF %2=="SCMRassets.sc2mod" set errormo2=1
		IF %2=="SCMRcinematics.SC2Mod" set errormo3=1
		IF %2=="SCMRlocal.SC2Mod" set errormo4=1
	)
GOTO :eof

:shortcut
set sht="%temp%\scmrshortcut.vbs"
if exist %sht% del /f /q %sht%
>%sht% echo Set oWS = WScript.CreateObject("WScript.Shell") 
>>%sht% echo sLinkFile = "%USERPROFILE%\Desktop\Mass Recall.lnk"
>>%sht% echo Set oLink = oWS.CreateShortcut(sLinkFile)
>>%sht% echo oLink.TargetPath = "%cd%\%support%"
>>%sht% echo oLink.Arguments = chr(34)+"%cd%\Maps\Starcraft Mass Recall\SCMR Campaign Launcher.SC2Map"+chr(34)
>>%sht% echo oLink.IconLocation = "%cd%\Maps\Starcraft Mass Recall\icon.ico"
>>%sht% echo oLink.Save
cscript //nologo %sht%
if exist %sht% del /f /q %sht%
GOTO :eof

:unzip 
set vbs="%temp%\scmrunzip.vbs"
if exist %vbs% del /f /q %vbs%
>%vbs%  echo Set fso = CreateObject("Scripting.FileSystemObject")
>>%vbs% echo If NOT fso.FolderExists(%1) Then
>>%vbs% echo fso.CreateFolder(%1)
>>%vbs% echo End If
>>%vbs% echo set objShell = CreateObject("Shell.Application")
>>%vbs% echo set FilesInZip=objShell.NameSpace(%2).items
>>%vbs% echo objShell.NameSpace(%1).CopyHere FilesInZip, 16
>>%vbs% echo Set fso = Nothing
>>%vbs% echo Set objShell = Nothing
cscript //nologo %vbs%
if exist %vbs% del /f /q %vbs%
GOTO :eof